#  Copyright 2020 Google LLC
#  Copyright 2020 EPAM Systems
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.


from flask import Flask, json, request, url_for

OSDU_INGEST_SUCCES_FIFO = "/tmp/osdu_ingest_success"
OSDU_INGEST_FAILED_FIFO = "/tmp/osdu_ingest_failed"

app = Flask(__name__)

@app.route('/')
def index():
    return 'index'

@app.route('/st', methods=['POST', 'GET', "PUT"])
def storage():
    print(request.json)
    with open("/tmp/osdu_ingest_result", "w") as f:
        json.dump(request.get_json(), f)
        f.close()
    return json.dumps({"recordIds": ["aaa"]}), 201


@app.route('/wf/us', methods=['POST', 'GET', "PUT"])
def workflow():
    print(request)
    print(request.headers)
    print(request.json)
    content = request.get_json(force=True)
    print(content)
    if content.get("Status") == "finished":
        None
    if content.get("Status") == "failed":
        with open("/tmp/result", "w") as f:
            f.write("2")
    return json.dumps({"recordIds": [1]}), 200

COUNTER = 1

@app.route('/sr/qr', methods=['POST', 'GET', "PUT"])
def search():
    global COUNTER
    tmp = COUNTER
    return json.dumps({"totalCount": tmp}), 200
